import java.math.*;


public class averages2 {

    /**Main loop*/

    public static void main (String args[]) {
	System.out.println("start");
	for(int n=2;n<600;++n) {
	    doTest(n);
	    if(n%10==0) System.out.println("    "+n);
	}
	System.out.println("done");
    }

    /**This does the test*/
    public static void doTest(int n) {  
       int m1=phi(n);
       int m2=n-m1-1;
       BigInteger T1=product1(n,m1);
       BigInteger T2=product2(n,m2);
       BigInteger U1=power(T1,m2);
       BigInteger U2=power(T2,m1);
       int k=U1.compareTo(U2);
       if(k==1) System.out.println("bad");
    }


    /**Takes the kth power of the BigInteger.
       I think that this is the routine that
       causes the bottleneck in the program.*/

    public static BigInteger power(BigInteger A,int k) {
	BigInteger T=new BigInteger("1");
	for(int i=0;i<k;++i) T=T.multiply(A);
	return(T);
    }


    /**converts a int to a big integer*/
    public static BigInteger intToBigInteger(int n) {
	Integer n1=new Integer(n);
	BigInteger n2=new BigInteger(n1.toString());
	return(n2);
    }

    /**This computes the product of the first K numbers
       relatively prime to N.  The program will only work
       when K<=phi(N)*/


    public static BigInteger product1(int N,int k) {
	BigInteger T=new BigInteger("1");
	int count=0;
	int i=1;
	while((i<N)&&(count<k)) {
	    boolean test=relPrime(i,N);
	    if(test==true) {
		BigInteger I=intToBigInteger(i);
		T=T.multiply(I);
		++count;
	    }
	    ++i;
	}
	return(T);
    }

    /**This computes the product of the first K numbers
       not relatively prime to N.  The program will only
       work when K<=N-phi(N)*/

    public static BigInteger product2(int N,int k) {
	BigInteger T=new BigInteger("1");
	int count=0;
	int i=1;
	while((i<N)&&(count<k)) {
	    boolean test=relPrime(i,N);
	    if(test==false) {
		BigInteger I=intToBigInteger(i);
		T=T.multiply(I);
		++count;
	    }
	    ++i;
	}
	return(T);
    }


    /**Computes the Euler phi function*/
    public static int phi(int n) {
	int count=0;
	for(int i=0;i<n;++i) {
	    boolean test=relPrime(i,n);
	    if(test==true) ++count;
	}
	return(count);
    }

    /**Computes the greatest common divisor*/
     public static int GCD(int a,int b) {
	 int g=a;
	 int h=b;
	 int t;
       while(h!=0) {
           t=g-(g/h)*h;
           g=h;
           h=t;
       }
      return(g);
     }


    /**Tests if the numbers are relatively prime*/
    public static boolean relPrime(int a,int b) {
       int x=GCD(a,b);
       if(x==1) return(true);
       return(false);
    }

}

